最大子段和问题(暴力、分治、贪心、动态规划)

最大子段和问题

暴力

前缀和预处理

分治法(不会😣)

贪心

动态规划


题目整理

LeetCode 53. 最大子序和

https://leetcode-cn.com/problems/maximum-subarray/

LeetCode官方题解:https://leetcode-cn.com/problems/maximum-subarray/solution/zui-da-zi-xu-he-by-leetcode/

力扣题解中给出了分治法贪心动态规划三种解法。分治法不懂……

下面这个做法是贪心,如果负了就舍去。

class Solution {
public:
    int maxSubArray(vector<int> &nums) {
        int ans = nums[0];
        int sum = nums[0];
        int Size = nums.size();
        for (int i = 1; i < Size; ++i) {
            if (sum > 0) {
                sum += nums[i];
            } else {
                sum = nums[i];
            }
            ans = max(ans, sum);
        }
        return ans;
    }
};

Max Sum HDU - 1003

https://vjudge.net/problem/HDU-1003

                                                Max Sum

                            Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
                                               Total Submission(s): 347894    Accepted Submission(s): 82801


Problem Description

Given a sequence a[1],a[2],a[3]......a[n], your job is to calculate the max sum of a sub-sequence. For example, given (6,-1,5,4,-7), the max sum in this sequence is 6 + (-1) + 5 + 4 = 14.
 

Input

The first line of the input contains an integer T(1<=T<=20) which means the number of test cases. Then T lines follow, each line starts with a number N(1<=N<=100000), then N integers followed(all the integers are between -1000 and 1000).
 

Output

For each test case, you should output two lines. The first line is "Case #:", # means the number of the test case. The second line contains three integers, the Max Sum in the sequence, the start position of the sub-sequence, the end position of the sub-sequence. If there are more than one result, output the first one. Output a blank line between two cases.
 

Sample Input

2

5 6 -1 5 4 -7

7 0 6 -1 1 -6 7 -5

Sample Output

Case 1: 14 1 4

Case 2: 7 1 6

 

这个记录区间的方法一开始没想出来……

Code:

#include <cstdio>
#include <vector>
using namespace std;
typedef long long ll;

//贪心
int maxSubArray(vector<int> &nums, int &beginMax, int &endMax)
{
	int ans = -100000;
	int sum = 0;
	int Size = nums.size();
	beginMax = 0, endMax = -1;
	int beginTemp = 0, endTemp = -1;
	for (int i = 0; i < Size; ++i)
	{
		sum += nums[i];
		endTemp++;
		if (sum > ans)
		{
			ans = sum;
			beginMax = beginTemp;
			endMax = endTemp;
		}
		if (sum < 0)
		{
			sum = 0;
			beginTemp = i + 1;
			endTemp = i;
		}
	}
	return ans;
}

int main()
{
	int T;
	scanf("%d", &T);
	for (int t = 1; t <= T; t++)
	{
		int n, x;
		scanf("%d", &n);
		vector<int> v;
		for (int i = 0; i < n; i++)
		{
			scanf("%d", &x);
			v.push_back(x);
		}
		int maxsum, _begin, _end;
		maxsum = maxSubArray(v, _begin, _end);
		printf("Case %d:\n", t);
		printf("%d %d %d\n", maxsum, ++_begin, ++_end);
		if (t != T) printf("\n");
	}
	return 0;
}

洛谷 P1115 最大子段和

https://www.luogu.com.cn/problem/P1115

动态规划,这个方法我是觉得最好理解。

#include <bits/stdc++.h>
using namespace std;
int n;
int a[200002];
int dp[200002];
int main()
{
	int ans = -0x3f3f3f3f;
	scanf("%d", &n);
	for (int i = 1; i <= n; i++)
		scanf("%d", &a[i]);
	for (int j = 1; j <= n; j++)
	{
		dp[j] = max(dp[j - 1] + a[j], a[j]);
		ans = max(ans, dp[j]);
	}
	printf("%d\n", ans);
	return 0;
}

 

  • 0
    点赞
  • 2
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值